#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivitySmashEggCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivitySmashEggCFG> M_ActivitySmashEggCFG::msSingleton(nullptr);

int M_ActivitySmashEggCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySmashEggCFGData* M_ActivitySmashEggCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivitySmashEggCFGData>& M_ActivitySmashEggCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySmashEggCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivitySmashEggCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySmashEggCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mEggName = element->Attribute("EggName");
		data.mHammerId = element->IntAttribute("HammerId");
		data.mHammerCount = element->IntAttribute("HammerCount");
		data.mIntegralId = element->IntAttribute("IntegralId");
		data.mIntegralCount = element->IntAttribute("IntegralCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivitySmashEggCFG::Load()
{
	Load("../Config/M_ActivitySmashEggCFG.xml");
}

M_ActivitySmashEggCFG* M_ActivitySmashEggCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySmashEggCFG());
	}
	return msSingleton.get();
}
